diff -Nur olsrd-0.5.0.cvs/lib/bmf/src/Bmf.c olsrd-0.5.0/lib/bmf/src/Bmf.c
--- olsrd-0.5.0.cvs/lib/bmf/src/Bmf.c	2007-06-23 13:15:19.000000000 +0200
+++ olsrd-0.5.0/lib/bmf/src/Bmf.c	2007-05-13 04:28:38.000000000 +0200
@@ -844,14 +895,16 @@
     8,
     "%s: outgoing pkt of %ld bytes captured on tuntap interface \"%s\": %s->%s\n",
     PLUGIN_NAME_SHORT,
-    (long)ethernetFrameLen,
+    (long)ipPacketLen,
     EtherTunTapIfName,
     olsr_ip_to_string(&srcIp),
     olsr_ip_to_string(&dstIp));
 
+  /* Calculate packet fingerprint */
+  crc32 = PacketCrc32(ipPacket, ipPacketLen);
+
   /* Check if this packet was seen recently */
-  crc32 = PacketCrc32(ethernetFrame, ethernetFrameLen);
-  if (CheckAndMarkRecentPacket(Hash16(crc32)))
+  if (CheckAndMarkRecentPacket(crc32))
   {
     OLSR_PRINTF(
       8,
@@ -863,6 +916,9 @@
   /* Compose encapsulation header */
   encapHdr = (struct TEncapHeader*) encapsulationUdpData;
   memset (encapHdr, 0, ENCAP_HDR_LEN);
+  encapHdr->type = BMF_ENCAP_TYPE;
+  encapHdr->len = BMF_ENCAP_LEN;
+  encapHdr->reserved = 0;
   encapHdr->crc32 = htonl(crc32);
 
   /* Check with each network interface what needs to be done on it */
@@ -883,19 +939,37 @@
        * Answer 2 (better): Forward it. */
 
       int nBytesWritten;
+      struct sockaddr_ll dest;
 
-      /* Change source MAC address to that of sending interface */
-      SetFrameSourceMac(ethernetFrame, walker->macAddr);
-
-      /* If the encapsulated Ethernet frame is an IP local broadcast packet,
+      /* If the encapsulated IP packet is a local broadcast packet,
        * update its destination address to match the subnet of the network
        * interface on which the packet is being sent. */
-      CheckAndUpdateLocalBroadcast(GetIpPacket(ethernetFrame), &walker->broadAddr);
+      CheckAndUpdateLocalBroadcast(ipPacket, &walker->broadAddr);
 
-      nBytesWritten = write(walker->capturingSkfd, ethernetFrame, ethernetFrameLen);
-      if (nBytesWritten != ethernetFrameLen)
+      memset(&dest, 0, sizeof(dest));
+      dest.sll_family = AF_PACKET;
+      dest.sll_protocol = htons(ETH_P_IP);
+      dest.sll_ifindex = if_nametoindex(walker->ifName);
+      dest.sll_halen = IFHWADDRLEN;
+
+      /* Use all-ones as destination MAC address. When the IP destination is
+       * a multicast address, the destination MAC address should normally also
+       * be a multicast address. E.g., when the destination IP is 224.0.0.1,
+       * the destination MAC should be 01:00:5e:00:00:01. However, it does not
+       * seem to matter when the destination MAC address is set to all-ones
+       * in that case. */
+      memset(dest.sll_addr, 0xFF, IFHWADDRLEN);
+
+      nBytesWritten = sendto(
+        walker->capturingSkfd,
+        ipPacket,
+        ipPacketLen,
+        0,
+        (struct sockaddr*) &dest,
+        sizeof(dest));
+      if (nBytesWritten != ipPacketLen)
       {
-        BmfPError("write() error forwarding pkt on \"%s\"", walker->ifName);
+        BmfPError("sendto() error forwarding pkt on \"%s\"", walker->ifName);
       }
       else
       {
@@ -910,7 +984,7 @@
       } /* if */
     } /* if */
   } /* for */
-}
+} /* BmfTunPacketCaptured */
 
 /* -------------------------------------------------------------------------
  * Function   : DoBmf
@@ -959,7 +1033,7 @@
         struct sockaddr_ll pktAddr;
         socklen_t addrLen = sizeof(pktAddr);
         int nBytes;
-        unsigned char* ethernetFrame;
+        unsigned char* ipPacket;
 
         /* A packet was captured. */
 
@@ -967,10 +1041,10 @@
 
         /* Receive the captured Ethernet frame, leaving space for the BMF
          * encapsulation header */
-        ethernetFrame = GetEthernetFrame(rxBuffer);
+        ipPacket = GetIpPacket(rxBuffer);
         nBytes = recvfrom(
           skfd,
-          ethernetFrame,
+          ipPacket,
           BMF_BUFFER_SIZE - ENCAP_HDR_LEN,
           0,
           (struct sockaddr*)&pktAddr,
@@ -982,13 +1056,13 @@
           continue; /* for */
         } /* if (nBytes < 0) */
 
-        /* Check if the number of received bytes is large enough for an Ethernet
-         * frame which contains at least a minimum-size IP header.
+        /* Check if the number of received bytes is large enough for an IP
+         * packet which contains at least a minimum-size IP header.
          * Note: There is an apparent bug in the packet socket implementation in
          * combination with VLAN interfaces. On a VLAN interface, the value returned
          * by 'recvfrom' may (but need not) be 4 (bytes) larger than the value
          * returned on a non-VLAN interface, for the same ethernet frame. */
-        if (nBytes < IP_HDR_OFFSET + (int)sizeof(struct ip))
+        if (nBytes < (int)sizeof(struct ip))
         {
           olsr_printf(
             1,
@@ -1047,8 +1121,13 @@
           continue; /* for */
         } /* if (nBytes < 0) */
 
+        /* Check if the received packet is actually directed to another
+         * node on the LAN */
         if (pktAddr.sll_pkttype != PACKET_OTHERHOST)
         {
+          /* No, the packet is directed to this node. In that case it will
+           * be, or will already have been received, via the encapsulating
+           * socket. Discard it here. */
           continue; /* for */
         } /* if (pktAddr.sll_pkttype ...) */
 
@@ -1060,7 +1139,7 @@
           continue; /* for */
         }
 
-        udpHeader = (struct udphdr*)(rxBuffer + GetHeaderLength(rxBuffer));
+        udpHeader = (struct udphdr*)(rxBuffer + GetIpHeaderLength(rxBuffer));
         destPort = ntohs(udpHeader->dest);
         if (destPort != BMF_ENCAP_PORT)
         {
@@ -1079,7 +1158,7 @@
          * not) be 4 (bytes) larger than the value returned on a non-VLAN interface, for
          * the same ethernet frame. */
         minimumLength =
-          GetHeaderLength(rxBuffer) +
+          GetIpHeaderLength(rxBuffer) +
           sizeof(struct udphdr) +
           ENCAP_HDR_LEN +
           IP_HDR_OFFSET +
@@ -1102,7 +1181,7 @@
           walker,
           &forwardedBy,
           &forwardedTo,
-          rxBuffer + GetHeaderLength(rxBuffer) + sizeof(struct udphdr));
+          rxBuffer + GetIpHeaderLength(rxBuffer) + sizeof(struct udphdr));
 
       } /* if (skfd >= 0 && (FD_ISSET...)) */
     } /* for */
@@ -1157,6 +1236,10 @@
           continue; /* for */
         }
 
+        /* Unfortunately, the recvfrom call does not return the destination
+         * of the encapsulation packet (the destination may be either the
+         * my unicast or my local broadcast address). Therefore we fill in 'NULL'
+         * for the 'forwardedTo' parameter. */
         BmfEncapsulationPacketReceived(walker, &forwardedBy, NULL, rxBuffer);
 
       } /* if (skfd >= 0 && (FD_ISSET...)) */
@@ -1168,43 +1251,17 @@
        * network interface */
 
       int nBytes;
-      unsigned char* ethernetFrame;
+      unsigned char* ipPacket;
       unsigned char* bufferToRead;
       size_t nBytesToRead;
 
       nFdBitsSet--;
 
       /* Receive the packet, leaving space for the BMF encapsulation header */
-      ethernetFrame = GetEthernetFrame(rxBuffer);
+      ipPacket = GetIpPacket(rxBuffer);
     
-      bufferToRead = ethernetFrame;
+      bufferToRead = ipPacket;
       nBytesToRead = BMF_BUFFER_SIZE - ENCAP_HDR_LEN;
-      if (TunOrTap == TT_TUN)
-      {
-        u_int16_t type;
-
-        /* When using a tun-interface, also leave space for an Ethernet header */
-        bufferToRead += IP_HDR_OFFSET;
-        nBytesToRead -= IP_HDR_OFFSET;
-
-        /* Compose a valid Ethernet header, for other BMF-nodes which may be
-         * receiving their BMF packets on a tap-interface. */
-
-        /* Use all-ones as destination MAC address. When the IP destination is
-         * a multicast address, the destination MAC address should normally also
-         * be a multicast address. E.g., when the destination IP is 224.0.0.1,
-         * the destination MAC should be 01:00:5e:00:00:01. However, it does not
-         * seem to matter when the destination MAC address is set to all-ones
-         * in that case. */
-        memset(ethernetFrame, 0xFF, IFHWADDRLEN);
-
-        /* Source MAC address is not important. Set to all-zeros */
-        memset(ethernetFrame + IFHWADDRLEN, 0x00, IFHWADDRLEN);
-
-        /* Ethertype = 0800 = IP */
-        type = htons(0x0800);
-        memcpy(ethernetFrame + ETH_TYPE_OFFSET, &type, 2);
-      }
 
       nBytes = read(EtherTunTapFd, bufferToRead, nBytesToRead);
 
@@ -1214,13 +1271,9 @@
       }
       else
       {
-        /* Check if the number of received bytes is large enough for an Ethernet
-         * frame which contains at least a minimum-size IP header */
-        if (TunOrTap == TT_TUN)
-        {
-          nBytes += IP_HDR_OFFSET;
-        }
-        if (nBytes < IP_HDR_OFFSET + (int)sizeof(struct ip))
+        /* Check if the number of received bytes is large enough for an IP
+         * packet which contains at least a minimum-size IP header */
+        if (nBytes < (int)sizeof(struct ip))
         {
           olsr_printf(
             1,
@@ -1235,11 +1288,11 @@
 
           BmfTunPacketCaptured(rxBuffer);
 
-        } /* if (nBytes < IP_HDR_OFFSET... */
+        } /* if (nBytes < ... */
       } /* if (nBytes < 0) */
     } /* if (nFdBitsSet > 0 && ... */
   } /* while (nFdBitsSet > 0) */
-}
+} /* DoBmf */
 
 /* -------------------------------------------------------------------------
  * Function   : BmfSignalHandler
@@ -1252,7 +1305,7 @@
 static void BmfSignalHandler(int signo __attribute__((unused)))
 {
   BmfThreadRunning = 0;
-}
+} /* BmfSignalHandler */
 
 /* -------------------------------------------------------------------------
  * Function   : BmfRun
@@ -1293,7 +1346,7 @@
   }
 
   return NULL;
-}
+} /* BmfRun */
 
 /* -------------------------------------------------------------------------
  * Function   : InterfaceChange
@@ -1338,8 +1391,9 @@
       interf->int_name, action);
     break;
   }
+
   return 0;
-}
+} /* InterfaceChange */
 
 /* -------------------------------------------------------------------------
  * Function   : InitBmf
@@ -1376,7 +1430,7 @@
   }
 
   return 1;
-}
+} /* InitBmf */
 
 /* -------------------------------------------------------------------------
  * Function   : CloseBmf
@@ -1384,7 +1438,7 @@
  * Input      : none
  * Output     : none
  * Return     : none
- * Data Used  : BmfThreadRunning, BmfThread
+ * Data Used  : BmfThread
  * ------------------------------------------------------------------------- */
 void CloseBmf(void)
 {
@@ -1414,7 +1468,7 @@
 
   /* Clean up after the BmfThread has been killed */
   CloseBmfNetworkInterfaces();
-}
+} /* CloseBmf */
 
 /* -------------------------------------------------------------------------
  * Function   : RegisterBmfParameter
@@ -1427,11 +1481,7 @@
  * ------------------------------------------------------------------------- */
 int RegisterBmfParameter(char* key, char* value)
 {
-  if (strcmp(key, "DropMac") == 0)
-  {
-    return DropMac(value);
-  }
-  else if (strcmp(key, "NonOlsrIf") == 0)
+  if (strcmp(key, "NonOlsrIf") == 0)
   {
     return AddNonOlsrBmfIf(value);
   }
@@ -1443,10 +1493,6 @@
   {
     return SetBmfInterfaceName(value);
   }
-  else if (strcmp(key, "BmfInterfaceType") == 0)
-  {
-    return SetBmfInterfaceType(value);
-  }
   else if (strcmp(key, "BmfInterfaceIp") == 0)
   {
     return SetBmfInterfaceIp(value);
@@ -1462,5 +1508,5 @@
 
   /* Key not recognized */
   return 0;
-}
+} /* RegisterBmfParameter */
 
diff -Nur olsrd-0.5.0.cvs/lib/bmf/src/Bmf.h olsrd-0.5.0/lib/bmf/src/Bmf.h
--- olsrd-0.5.0.cvs/lib/bmf/src/Bmf.h	2007-06-23 13:15:19.000000000 +0200
+++ olsrd-0.5.0/lib/bmf/src/Bmf.h	2007-05-13 04:29:02.000000000 +0200
@@ -3,7 +3,7 @@
 
 /*
  * OLSR Basic Multicast Forwarding (BMF) plugin.
- * Copyright (c) 2005, 2006, Thales Communications, Huizen, The Netherlands.
+ * Copyright (c) 2005 - 2007, Thales Communications, Huizen, The Netherlands.
  * Written by Erik Tromp.
  * All rights reserved.
  *
@@ -43,9 +43,9 @@
 /* BMF plugin data */
 #define PLUGIN_NAME "OLSRD Basic Multicast Forwarding (BMF) plugin"
 #define PLUGIN_NAME_SHORT "OLSRD BMF"
-#define PLUGIN_VERSION "1.4 (" __DATE__ " " __TIME__ ")"
+#define PLUGIN_VERSION "1.5 (" __DATE__ " " __TIME__ ")"
 #define PLUGIN_COPYRIGHT "  (C) Thales Communications Huizen, Netherlands"
-#define PLUGIN_AUTHOR "  Erik Tromp (erik.tromp@nl.thalesgroup.com)"
+#define PLUGIN_AUTHOR "  Erik Tromp (eriktromp@users.sourceforge.net)"
 #define MOD_DESC PLUGIN_NAME " " PLUGIN_VERSION "\n" PLUGIN_COPYRIGHT "\n" PLUGIN_AUTHOR
 
 /* UDP-Port on which multicast packets are encapsulated */
diff -Nur olsrd-0.5.0.cvs/lib/bmf/src/NetworkInterfaces.c olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.c
--- olsrd-0.5.0.cvs/lib/bmf/src/NetworkInterfaces.c	2007-06-23 13:15:19.000000000 +0200
+++ olsrd-0.5.0/lib/bmf/src/NetworkInterfaces.c	2007-05-13 04:29:24.000000000 +0200
@@ -1,6 +1,6 @@
 /*
  * OLSR Basic Multicast Forwarding (BMF) plugin.
- * Copyright (c) 2005, 2006, Thales Communications, Huizen, The Netherlands.
+ * Copyright (c) 2005 - 2007, Thales Communications, Huizen, The Netherlands.
  * Written by Erik Tromp.
  * All rights reserved.
  *
@@ -50,7 +50,7 @@
 #include <assert.h> /* assert() */
 #include <net/if.h> /* socket(), ifreq, if_indextoname(), if_nametoindex() */
 #include <netinet/in.h> /* htons() */
-#include <linux/if_ether.h> /* ETH_P_ALL */
+#include <linux/if_ether.h> /* ETH_P_IP */
 #include <linux/if_packet.h> /* packet_mreq, PACKET_MR_PROMISC, PACKET_ADD_MEMBERSHIP */
 #include <linux/if_tun.h> /* IFF_TAP */
 #include <netinet/ip.h> /* struct ip */
@@ -87,12 +87,6 @@
  * setting the plugin parameter "BmfInterface". */
 char EtherTunTapIfName[IFNAMSIZ] = "bmf0";
 
-/* If the plugin parameter "BmfInterfaceType" is set to "tap", an
- * EtherTap interface will be used, and this variable will be set to TT_TAP. If
- * "BmfInterfaceType" is set to "tun" or not set at all, an IP tunnel interface 
- * used, and this variable will be set to TT_TUN. */
-enum TTunOrTap TunOrTap = TT_TUN;
-
 /* The underlying mechanism to forward multicast packets. Either:
  * - BM_BROADCAST: BMF uses the IP local broadcast as destination address
  * - BM_UNICAST_PROMISCUOUS: BMF uses the IP address of the best neighbor as
@@ -136,33 +130,7 @@
   strncpy(EtherTunTapIfName, ifname, IFNAMSIZ - 1);
   EtherTunTapIfName[IFNAMSIZ - 1] = '\0'; /* Ensures null termination */
   return 1;
-}
-
-/* -------------------------------------------------------------------------
- * Function   : SetBmfInterfaceType
- * Description: Overrule the default network interface type ("tun") of the
- *              EtherTunTap interface
- * Input      : iftype - network interface type, either "tun" or "tap"
- * Output     : none
- * Return     : fail (0) or success (1)
- * Data Used  : none
- * ------------------------------------------------------------------------- */
-int SetBmfInterfaceType(const char* iftype)
-{
-  if (strcmp(iftype, "tun") == 0)
-  {
-    TunOrTap = TT_TUN;
-    return 1;
-  }
-  else if (strcmp(iftype, "tap") == 0)
-  {
-    TunOrTap = TT_TAP;
-    return 1;
-  }
-
-  /* Value not recognized */
-  return 0;
-}
+} /* SetBmfInterfaceName */
 
 /* -------------------------------------------------------------------------
  * Function   : SetBmfInterfaceIp
@@ -223,7 +191,7 @@
 
   /* Compose IP broadcast address in host byte order */
   EtherTunTapIpBroadcast = EtherTunTapIp;
-  for (i=prefixLen; i < IPV4_MAX_PREFIXLEN; i++)
+  for (i = prefixLen; i < IPV4_MAX_PREFIXLEN; i++)
   {
     EtherTunTapIpBroadcast |= (1 << (IPV4_MAX_PREFIXLEN - 1 - i));
   }
@@ -231,7 +199,7 @@
   TunTapIpOverruled = 1;
 
   return 1;
-}
+} /* SetBmfInterfaceIp */
 
 /* -------------------------------------------------------------------------
  * Function   : SetCapturePacketsOnOlsrInterfaces
@@ -257,7 +225,7 @@
 
   /* Value not recognized */
   return 0;
-}
+} /* SetCapturePacketsOnOlsrInterfaces */
 
 /* -------------------------------------------------------------------------
  * Function   : SetBmfMechanism
@@ -283,7 +251,7 @@
 
   /* Value not recognized */
   return 0;
-}
+} /* SetBmfMechanism */
 
 /* -------------------------------------------------------------------------
  * Function   : AddDescriptorToInputSet
@@ -304,7 +272,7 @@
 
   /* Add descriptor to input set */
   FD_SET(skfd, &InputSet);
-}
+} /* AddDescriptorToInputSet */
 
 /* To save the state of the IP spoof filter for the EtherTunTap interface */
 static char EthTapSpoofState = '1';
@@ -366,7 +334,7 @@
   fclose(procSpoof);
 
   return 1;
-}
+} /* DeactivateSpoofFilter */
 
 /* -------------------------------------------------------------------------
  * Function   : RestoreSpoofFilter
@@ -398,7 +366,7 @@
     fputc(EthTapSpoofState, procSpoof);
     fclose(procSpoof);
   }
-}
+} /* RestoreSpoofFilter */
 
 #ifndef USING_THALES_LINK_COST_ROUTING
 /* -------------------------------------------------------------------------
@@ -421,35 +389,41 @@
   {
     return 1.0 / (loss * neigh_loss);
   }
-}
+} /* CalcEtx */
 #endif /* USING_THALES_LINK_COST_ROUTING */
 
 /* -------------------------------------------------------------------------
- * Function   : GetBestNeighbor
- * Description: Get the best neighbor on an interface to send a BMF packet to
+ * Function   : GetBestTwoNeighbors
+ * Description: Find at most two best neighbors on a network interface to forward
+ *              a BMF packet to
  * Input      : intf - the network interface
  *              source - the source IP address of the BMF packet 
  *              forwardedBy - the IP address of the node that forwarded the BMF
  *                packet
  *              forwardedTo - the IP address of the node to which the BMF packet
- *                was directed 
+ *                was directed
  * Output     : nPossibleNeighbors - number of found possible neighbors
- * Return     : the best neighbor, or NULL if none found
+ * Return     : The list of the two best neighbors. If only one best neighbor is
+ *              found, the second list entry is NULL. If no neigbors are found,
+ *              the first and second list entries are both NULL.
  * Data Used  : none
  * ------------------------------------------------------------------------- */
-struct link_entry* GetBestNeighbor(
+struct TBestNeighbors GetBestTwoNeighbors(
   struct TBmfInterface* intf,
   union olsr_ip_addr* source,
   union olsr_ip_addr* forwardedBy,
   union olsr_ip_addr* forwardedTo,
   int* nPossibleNeighbors)
 {
+  struct TBestNeighbors result;
+  result.links[0] = NULL;
+  result.links[1] = NULL;
+
   /* handle the non-LQ case */
 
   if (olsr_cnf->lq_level == 0)
   {
     struct link_entry* walker;
-    struct link_entry* bestLink = NULL;
     *nPossibleNeighbors = 0;
 
     /* TODO: get_link_set() is not thread-safe! */
@@ -513,34 +487,18 @@
 
       *nPossibleNeighbors += 1;
 
-      /* Remember the first found link */
-      if (bestLink == NULL)
+      /* In the non-LQ case, it is not possible to select neigbors
+       * by quality or cost. So just remember the first two found links. */
+      if (result.links[0] == NULL)
       {
-        bestLink = walker;
+        result.links[0] = walker;
       }
-
+      else if (result.links[1] == NULL)
+      {
+        result.links[1] = walker;
+      } /* if */
     } /* for */
 
-    if (bestLink == NULL)
-    {
-      OLSR_PRINTF(
-        9,
-        "%s: ----> No suitable neighbor found to forward to on \"%s\"\n",
-        PLUGIN_NAME_SHORT,
-        intf->ifName);
-    }
-    else
-    {
-      OLSR_PRINTF(
-        9,
-        "%s: ----> Best %sneighbor to forward to on \"%s\" is %s\n",
-        PLUGIN_NAME_SHORT,
-        *nPossibleNeighbors == 1 ? "(and only) " : "",
-        intf->ifName,
-        olsr_ip_to_string(&bestLink->neighbor_iface_addr));
-    }
-
-    return bestLink;
   }
   /* handle the LQ case */
   else
@@ -548,9 +506,9 @@
 #ifdef USING_THALES_LINK_COST_ROUTING
 
     struct link_entry* walker;
-    struct link_entry* bestLink = NULL;
     float previousLinkCost = INFINITE_COST;
     float bestLinkCost = INFINITE_COST;
+    float oneButBestLinkCost = INFINITE_COST;
     *nPossibleNeighbors = 0;
 
     if (forwardedBy != NULL)
@@ -709,41 +667,26 @@
 
       *nPossibleNeighbors += 1;
 
-      /* Remember the best link. If all are very bad, remember none. */
+      /* Remember the best two links. If all are very bad, remember none. */
       if (walker->link_cost < bestLinkCost)
       {
-        bestLink = walker;
+        result.links[1] = result.links[0];
+        result.links[0] = walker;
         bestLinkCost = walker->link_cost;
-	    }
+      }
+      else if (walker->link_cost < oneButBestLinkCost)
+      {
+        result.links[1] = walker;
+        oneButBestLinkCost = walker->link_cost;
+      } /* if */
     } /* for */
 
-    if (bestLink == NULL)
-    {
-      OLSR_PRINTF(
-        9,
-        "%s: ----> No suitable neighbor found to forward to on \"%s\"\n",
-        PLUGIN_NAME_SHORT,
-        intf->ifName);
-    }
-    else
-    {
-      OLSR_PRINTF(
-        9,
-        "%s: ----> Best %sneighbor to forward to on \"%s\" is %s\n",
-        PLUGIN_NAME_SHORT,
-        *nPossibleNeighbors == 1 ? "(and only) " : "",
-        intf->ifName,
-        olsr_ip_to_string(&bestLink->neighbor_iface_addr));
-    }
-
-    return bestLink;
-
 #else /* USING_THALES_LINK_COST_ROUTING */
         
     struct link_entry* walker;
-    struct link_entry* bestLink = NULL;
     float previousLinkEtx = INFINITE_ETX;
     float bestEtx = INFINITE_ETX; 
+    float oneButBestEtx = INFINITE_ETX; 
     *nPossibleNeighbors = 0;
 
     if (forwardedBy != NULL)
@@ -919,40 +862,60 @@
 
       *nPossibleNeighbors += 1;
 
-      /* Remember the best link. If all are very bad, remember none. */
+      /* Remember the best two links. If all are very bad, remember none. */
       if (currEtx < bestEtx)
       {
-        bestLink = walker;
+        result.links[1] = result.links[0];
+        result.links[0] = walker;
         bestEtx = currEtx;
       }
-
+      else if (currEtx < oneButBestEtx)
+      {
+        result.links[1] = walker;
+        oneButBestEtx = currEtx;
+      } /* if */
     } /* for */
 
-    if (bestLink == NULL)
-    {
-      OLSR_PRINTF(
-        9,
-        "%s: ----> No suitable neighbor found to forward to on \"%s\"\n",
-        PLUGIN_NAME_SHORT,
-        intf->ifName);
-    }
-    else
+#endif /* USING_THALES_LINK_COST_ROUTING */
+
+  } /* if */
+
+  /* Display the result of the neighbor search */
+  if (result.links[0] == NULL)
+  {
+    OLSR_PRINTF(
+      9,
+      "%s: ----> No suitable neighbor found to forward to on \"%s\"\n",
+      PLUGIN_NAME_SHORT,
+      intf->ifName);
+  }
+  else
+  {
+    OLSR_PRINTF(
+      9,
+      "%s: ----> Best neighbor%s to forward to on \"%s\": ",
+      PLUGIN_NAME_SHORT,
+      *nPossibleNeighbors == 1 ? "" : "s",
+      intf->ifName);
+
+    OLSR_PRINTF(
+      9,
+      "%s",
+      olsr_ip_to_string(&result.links[0]->neighbor_iface_addr));
+
+    if (result.links[1] != NULL)
     {
       OLSR_PRINTF(
         9,
-        "%s: ----> Best %sneighbor to forward to on \"%s\" is %s\n",
-        PLUGIN_NAME_SHORT,
-        *nPossibleNeighbors == 1 ? "(and only) " : "",
-        intf->ifName,
-        olsr_ip_to_string(&bestLink->neighbor_iface_addr));
-    }
-
-    return bestLink;
-
-#endif /* USING_THALES_LINK_COST_ROUTING */
+        ", %s",
+        olsr_ip_to_string(&result.links[1]->neighbor_iface_addr));
+    } /* if */
 
+    OLSR_PRINTF(9, "\n");
   } /* if */
-} /* GetBestNeighbor */
+
+  return result;
+} /* GetBestTwoNeighbors */
 
 /* -------------------------------------------------------------------------
  * Function   : CreateCaptureSocket
@@ -961,7 +924,7 @@
  * Output     : none
  * Return     : the socket descriptor ( >= 0), or -1 if an error occurred
  * Data Used  : none
- * Notes      : The socket is a raw packet socket, bound to the specified
+ * Notes      : The socket is a cooked IP packet socket, bound to the specified
  *              network interface
  * ------------------------------------------------------------------------- */
 static int CreateCaptureSocket(const char* ifName)
@@ -971,8 +934,8 @@
   struct ifreq req;
   struct sockaddr_ll bindTo;
 
-  /* Open raw packet socket */
-  int skfd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL));
+  /* Open cooked IP packet socket */
+  int skfd = socket(PF_PACKET, SOCK_DGRAM, htons(ETH_P_IP));
   if (skfd < 0)
   {
     BmfPError("socket(PF_PACKET) error");
@@ -1004,7 +967,7 @@
   /* Bind the socket to the specified interface */
   memset(&bindTo, 0, sizeof(bindTo));
   bindTo.sll_family = AF_PACKET;
-  bindTo.sll_protocol = htons(ETH_P_ALL);
+  bindTo.sll_protocol = htons(ETH_P_IP);
   bindTo.sll_ifindex = ifIndex;
   memcpy(bindTo.sll_addr, req.ifr_hwaddr.sa_data, IFHWADDRLEN);
   bindTo.sll_halen = IFHWADDRLEN;
@@ -1027,17 +990,17 @@
   AddDescriptorToInputSet(skfd);
 
   return skfd;
-}
+} /* CreateCaptureSocket */
 
 /* -------------------------------------------------------------------------
  * Function   : CreateListeningSocket
  * Description: Create socket for promiscuously listening to BMF packets.
- *              Used when 'BmfMechanism' is BM_UNICAST_PROMISCUOUS
+ *              Used only when 'BmfMechanism' is BM_UNICAST_PROMISCUOUS
  * Input      : ifname - network interface (e.g. "eth0")
  * Output     : none
  * Return     : the socket descriptor ( >= 0), or -1 if an error occurred
  * Data Used  : none
- * Notes      : The socket is an UDP (datagram) packet socket, bound to the specified
+ * Notes      : The socket is a cooked IP packet socket, bound to the specified
  *              network interface
  * ------------------------------------------------------------------------- */
 static int CreateListeningSocket(const char* ifName)
@@ -1047,8 +1010,8 @@
   struct ifreq req;
   struct sockaddr_ll bindTo;
 
-  /* Open UDP packet socket */
-  int skfd = socket(PF_PACKET, SOCK_DGRAM, 0);
+  /* Open cooked IP packet socket */
+  int skfd = socket(PF_PACKET, SOCK_DGRAM, htons(ETH_P_IP));
   if (skfd < 0)
   {
     BmfPError("socket(PF_PACKET) error");
@@ -1076,11 +1039,11 @@
     close(skfd);
     return -1;
   }
-   
+
   /* Bind the socket to the specified interface */
   memset(&bindTo, 0, sizeof(bindTo));
   bindTo.sll_family = AF_PACKET;
-  bindTo.sll_protocol = htons(ETH_P_ALL);
+  bindTo.sll_protocol = htons(ETH_P_IP);
   bindTo.sll_ifindex = ifIndex;
   memcpy(bindTo.sll_addr, req.ifr_hwaddr.sa_data, IFHWADDRLEN);
   bindTo.sll_halen = IFHWADDRLEN;
@@ -1103,7 +1066,7 @@
   AddDescriptorToInputSet(skfd);
 
   return skfd;
-}
+} /* CreateListeningSocket */
 
 /* -------------------------------------------------------------------------
  * Function   : CreateEncapsulateSocket
@@ -1170,7 +1133,7 @@
   AddDescriptorToInputSet(skfd);
 
   return skfd;
-}
+} /* CreateEncapsulateSocket */
 
 /* -------------------------------------------------------------------------
  * Function   : CreateLocalEtherTunTap
@@ -1206,16 +1169,9 @@
   strncpy(ifreq.ifr_name, EtherTunTapIfName, IFNAMSIZ - 1);
   ifreq.ifr_name[IFNAMSIZ - 1] = '\0'; /* Ensures null termination */
 
-  /* Specify either the IFF_TAP flag for Ethernet frames, or the IFF_TUN flag for IP.
+  /* Specify the IFF_TUN flag for IP packets.
    * Specify IFF_NO_PI for not receiving extra meta packet information. */
-  if (TunOrTap == TT_TUN)
-  {
-    ifreq.ifr_flags = IFF_TUN;
-  }
-  else
-  {
-    ifreq.ifr_flags = IFF_TAP;
-  }
+  ifreq.ifr_flags = IFF_TUN;
   ifreq.ifr_flags |= IFF_NO_PI;
 
   if (ioctl(etfd, TUNSETIFF, (void *)&ifreq) < 0)
@@ -1349,7 +1305,7 @@
   close(ioctlSkfd);
 
   return etfd;
-}
+} /* CreateLocalEtherTunTap */
 
 /* -------------------------------------------------------------------------
  * Function   : CreateInterface
@@ -1533,7 +1489,7 @@
     ifName);
 
   return nOpened;
-}
+} /* CreateInterface */
 
 /* -------------------------------------------------------------------------
  * Function   : CreateBmfNetworkInterfaces
@@ -1641,7 +1597,7 @@
     olsr_printf(1, "%s: opened %d sockets\n", PLUGIN_NAME, nOpenedSockets);
   }
   return 0;
-}
+} /* CreateBmfNetworkInterfaces */
 
 /* -------------------------------------------------------------------------
  * Function   : AddInterface
@@ -1661,12 +1617,12 @@
   nOpened = CreateInterface(newIntf->int_name, newIntf);
 
   olsr_printf(1, "%s: opened %d sockets\n", PLUGIN_NAME, nOpened);
-}
+} /* AddInterface */
 
 /* -------------------------------------------------------------------------
  * Function   : CloseBmfNetworkInterfaces
  * Description: Closes every socket on each network interface used by BMF
- * Input      : newIntf - network interface to add
+ * Input      : none
  * Output     : none
  * Return     : none
  * Data Used  : none
@@ -1767,7 +1723,7 @@
     totalNonOlsrBmfPacketsRx,
     totalNonOlsrBmfPacketsRxDup,
     totalNonOlsrBmfPacketsTx);
-}
+} /* CloseBmfNetworkInterfaces */
 
 #define MAX_NON_OLSR_IFS 32
 static char NonOlsrIfNames[MAX_NON_OLSR_IFS][IFNAMSIZ];
@@ -1800,7 +1756,7 @@
   NonOlsrIfNames[nNonOlsrIfs][IFNAMSIZ - 1] = '\0'; /* Ensures null termination */
   nNonOlsrIfs++;
   return 1;
-}
+} /* AddNonOlsrBmfIf */
 
 /* -------------------------------------------------------------------------
  * Function   : IsNonOlsrBmfIf
@@ -1821,7 +1777,7 @@
     if (strncmp(NonOlsrIfNames[i], ifName, IFNAMSIZ) == 0) return 1;
   }
   return 0;
-}
+} /* IsNonOlsrBmfIf */
 
 /* -------------------------------------------------------------------------
  * Function   : CheckAndUpdateLocalBroadcast
@@ -1870,7 +1826,7 @@
     {
       /* Re-calculate UDP/IP checksum for new destination */
 
-      int ipHeaderLen = GetHeaderLength(ipPacket);
+      int ipHeaderLen = GetIpHeaderLength(ipPacket);
       struct udphdr* udph = (struct udphdr*) (ipPacket + ipHeaderLen);
 
       /* RFC 1624, Eq. 3: HC' = ~(~HC - m + m') */
@@ -1884,9 +1840,9 @@
       check = check + (check >> 16);
 
       udph->check = htons(check);
-     }
-  }
-}
+     } /* if */
+  } /* if */
+} /* CheckAndUpdateLocalBroadcast */
 
 /* -------------------------------------------------------------------------
  * Function   : AddMulticastRoute
@@ -1929,7 +1885,7 @@
     /* Continue anyway */
   }
   close(ioctlSkfd);
-}
+} /* AddMulticastRoute */
 
 /* -------------------------------------------------------------------------
  * Function   : DeleteMulticastRoute
@@ -1974,5 +1930,5 @@
       /* Continue anyway */
     }
     close(ioctlSkfd);
-  }
-}
+  } /* if */
+} /* DeleteMulticastRoute */
